
/*
'globals
string o2dir="c:\oxygenbasic"
string argOpenFile
string progname, configdir
string appdir
string dir
string caption = "O2HEdit - OxygenBasic Editor using Scintilla"
string winCaption = caption

'Settings
string compiler=o2dir+"\co2.exe"
string compilername="co2.exe"

string SciLib, ResLinker, RcCompiler, ResEditor, ExtEditor, OxyHelp, WinApiHelp
string fnt
sys fnz
bool LN_style_bold  'Line number: Bold
bool LN_style_italic 'Line number: Italic
int tabspaces
int scheme

sys hsci
string openFile, filt
sys mode '0=No File, 1=New File, 2=File Exists
bool changed
*/
string HH_Help="hh.exe"
string extEditor="Wordpad.exe"

crlf=chr(13,10)

include "O2HEditColors.inc"
'  include "Scintilla.inc"
 
includepath "$/inc/"
'include once "console.inc"

  include once "FileDialog.inc"
  include once "SysUtil.inc"

includepath ""
#include "O2HEditUtils.inc"

===========================================
includepath ""

' The IDs for the resources in O2HEdit.rc
include "O2HEditIds.inc"
' Text for ShortcutsDlg, Credits() 
include "O2HEditTexts.inc"
===========================================

macro gdItem(item) (GetDlgItem(hDlg, item))   'hDlg
def   hSciMsg SendMessage hSci,               'hSci


==============================================

'MAIN CODE
=============================================
 
dim nCmdline as asciiz ptr, hInstance as sys
&nCmdline = GetCommandLine
hInstance = GetModuleHandle(0)

progname=exe_name()
#ifdef make_exe
for x=len(progname) to 1 step-1
   if asc(progname,x)=47 or asc(progname,x)=92 then ' / or \
     configdir=mid(progname,1,x-1)
     exit for
   end if 
next
#else
   configdir=app_path("o2hedit.dll")
''   configdir=current_dir()
#endif

CreateArgV

'hard coded, will not work when compiling to binary without runtime
#ifdef make_exe
   if argc>0 then ArgOpenFile=arga[1]
#else
   if argc>1 then ArgOpenFile=arga[2]
#endif    

if ArgOpenFile then
  if not exist ArgOpenFile then ArgOpenFile=""
end if
if len(ArgOpenFile) then
  if not instr(ArgOpenFile,"\") then
    if not instr(ArgOpenFile,"/") then
      ArgOpenFile=current_dir() & "\" & ArgOpenFile
    end if
  end if
end if      

loadConfig()

'Scintilla control
sys hSciLib=LoadLibrary SciLib
if not hSciLib then
  'try with o2dir
  SciLib = o2dir+"\Scilexer.dll"
  hSciLib=LoadLibrary SciLib
  if not hSciLib then
    mbox "Unable to load " & o2dir & SciLib  & crlf & "Please Correct path in O2HEdit.cfg" & crlf & "Program will abort"
      ExitProcess(1)
  end if 
end if

#ifdef use_dll
   sys hResources = loadlibrary "O2HEdit.dll" 
   if not hResources then 
     mbox "Error: O2HEdit.dll not found" & crlf & "Program will abort"
     ExitProcess(1)
   end if
#else
   sys hResources = hInstance
#endif

' hot keys
sys hAccelTable=LoadAccelerators(hResources, IDR_ACCEL)


s = error()

if s then
  print s
  end
end if


function createTempFile(string file) as string
   string suffix=".o2bas" 
   for x=len(openfile) to 1 step -1
      if mid(openfile,x,1)="." then
        suffix=mid(openfile,x) : exit for
      end if
   next             
   string tmp = "tmp" & str(mod(GetTickCount(),100000)) & suffix
   s=GetText hSci 
   putfile tmp, s             
   return tmp
end function

sub compileFile(sys hDlg, bool change, optional string opt="")
   'Run/Compile .o2bas or .inc file if possible   
   hStatus=GdItem IDC_STATUSBAR
   string Prolog="   Running "
   string Epilog=""
   if opt="-c " then Prolog = "   Compiling " : Epilog = " to Binary"

  'file modified?
   string tmpfile
   if change=true then          
     'create temporay file
     tmpfile=createTempFile(openfile)
   end if
      
   'Run source code
   if not exist compiler then mbox compiler " does not exist" : exit function
   if change=true then
     StatText=Prolog & "temporary file " clipname(tmpfile) " with " & compilername & Epilog
     SendMessage(hStatus, SB_SETTEXT, 3, StatText)
     ShellExecute (null,"open", compiler, opt & tmpfile, null, SW_SHOW)
     Sleep(1000)
     if opt="-c " and change then    
       p=instr(tmpfile,".o2bas") : tmpfile2=mid(tmpfile,1,p-1) & ".exe"
       p=instr(openFile,".o2bas") : tmpfile3=mid(openFile,1,p-1) & ".exe"
       'Try to rename to openFile.exe
       if exist(tmpfile2) then 
         MoveFile(tmpfile2, tmpFile3)
         StatText=Prolog &  clipname(tmpfile3) " with " & compilername & Epilog         
       end if
     end if    
     'mbox "Deleting temporary file"
     DeleteFile(tmpfile)     
   else  
     StatText=Prolog & clipname(openfile) " with " & compilername & Epilog        
     SendMessage(hStatus, SB_SETTEXT, 3, StatText)
     ShellExecute (null,"open", compiler, opt & openFile, null, SW_SHOW)
   end if
   StatText = StatText & " - Ready" : SendMessage(hStatus, SB_SETTEXT, 3, StatText)
end sub


'Init StatusBar
sub initStatusBar(sys hDlg)
   sys hStatus
   int statwidths[] = {100, 150, 200,-1}
   hStatus=gdItem(IDC_STATUSBAR)
   SendMessage(hStatus, SB_SETPARTS, 4, &statwidths)
   SendMessage(hStatus, SB_SETTEXT, 0, "")
end sub

' Size statusbar and get height
function getStatusHeight(sys hDlg) as int
   RECT rcStatus
   hStatus = gdItem(IDC_STATUSBAR)
   SendMessage(hStatus, WM_SIZE, 0, 0)
   GetWindowRect(hStatus, &rcStatus)
   return rcStatus.bottom - rcStatus.top
end function

'Size ToolBar and get height
function getToolBarHeight(sys hDlg) as int
   RECT rc 
   hToolBar=gdItem(IDC_TOOLBAR)
   SendMessage(hToolBar, TB_AUTOSIZE, 0, 0)
   GetWindowRect(hToolBar, &rc)
   return rc.bottom - rc.top
end function

sub initToolBar(sys hDlg)
   indexbase 0
   
   TBADDBITMAP tbab
   % numbuttons 21
   TBBUTTON tbb[numbuttons]

   sys hToolBar = gdItem(IDC_TOOLBAR)   
   if hToolBar = NULL then
     MessageBox(0, "Could not create tool bar.", "Error", MB_OK or MB_ICONERROR)
   end if

   sys hToolBitmap = LoadImage( hResources, IDB_TOOLBAR, IMAGE_BITMAP, 0, 0, (LR_LOADTRANSPARENT | LR_LOADMAP3DCOLORS))
   if not hToolBitmap then
     Messagebox(0, "Load Bitmap Failed!","Error!",0 )
   end if  

   ' Send the TB_BUTTONSTRUCTSIZE message, which is required for
   ' backward compatibility.
   SendMessage( hToolBar, TB_BUTTONSTRUCTSIZE, sizeOf(TBBUTTON), 0 )
   SendMessage(hToolBar, TB_SETBUTTONSIZE, 0,  32 | 24<<16) 'MAKELONG(32,24))
   
   tbab.nID = hToolBitmap
         
   SendMessage(hToolBar, TB_ADDBITMAP, numbuttons, &tbab)

   tbb[0].fsStyle = TBSTYLE_SEP
               
   tbb[1].iBitmap   = 0
   tbb[1].fsState = TBSTATE_ENABLED
   tbb[1].fsStyle = TBSTYLE_BUTTON
   tbb[1].idCommand = IDM_FILE_NEW

   tbb[2].iBitmap = 1
   tbb[2].fsState = TBSTATE_ENABLED
   tbb[2].fsStyle = TBSTYLE_BUTTON
   tbb[2].idCommand = IDM_FILE_OPEN

   tbb[3].iBitmap = 2
   tbb[3].fsState = TBSTATE_ENABLED
   tbb[3].fsStyle = TBSTYLE_BUTTON
   tbb[3].idCommand = IDM_FILE_SAVE

   tbb[4].fsStyle = TBSTYLE_SEP

   tbb[5].iBitmap = 3
   tbb[5].fsState = TBSTATE_ENABLED
   tbb[5].fsStyle = TBSTYLE_BUTTON
   tbb[5].idCommand = IDM_EDIT_CUT

   tbb[6].iBitmap = 4
   tbb[6].fsState = TBSTATE_ENABLED
   tbb[6].fsStyle = TBSTYLE_BUTTON
   tbb[6].idCommand = IDM_EDIT_COPY

   tbb[7].iBitmap = 5
   tbb[7].fsState = TBSTATE_ENABLED
   tbb[7].fsStyle = TBSTYLE_BUTTON
   tbb[7].idCommand = IDM_EDIT_PASTE

   tbb[8].fsStyle = TBSTYLE_SEP

   tbb[9].iBitmap = 6
   tbb[9].fsState = TBSTATE_ENABLED
   tbb[9].fsStyle = TBSTYLE_BUTTON
   tbb[9].idCommand = IDM_EDIT_UNDO

   tbb[10].iBitmap = 7
   tbb[10].fsState = TBSTATE_ENABLED
   tbb[10].fsStyle = TBSTYLE_BUTTON
   tbb[10].idCommand = IDM_EDIT_REDO

   tbb[11].fsStyle = TBSTYLE_SEP

   tbb[12].iBitmap = 8
   tbb[12].fsState = TBSTATE_ENABLED
   tbb[12].fsStyle = TBSTYLE_BUTTON
   tbb[12].idCommand = IDM_FILE_CLOSE

   tbb[13].fsStyle = TBSTYLE_SEP

   tbb[14].iBitmap = 9
   tbb[14].fsState = TBSTATE_ENABLED
   tbb[14].fsStyle = TBSTYLE_BUTTON
   tbb[14].idCommand = IDM_SEARCH_FIND

   tbb[15].iBitmap = 10
   tbb[15].fsState = TBSTATE_ENABLED
   tbb[15].fsStyle = TBSTYLE_BUTTON
   tbb[15].idCommand = IDM_SEARCH_REPLACE

   tbb[16].fsStyle = TBSTYLE_SEP
   
   tbb[17].iBitmap = 11
   tbb[17].fsState = TBSTATE_ENABLED
   tbb[17].fsStyle = TBSTYLE_BUTTON
   tbb[17].idCommand = IDM_WINDOW_NEW

   tbb[18].iBitmap = 12
   tbb[18].fsState = TBSTATE_ENABLED
   tbb[18].fsStyle = TBSTYLE_BUTTON
   tbb[18].idCommand = IDM_TOOLS_DOS

   tbb[19].iBitmap = 13
   tbb[19].fsState = TBSTATE_ENABLED
   tbb[19].fsStyle = TBSTYLE_BUTTON
   tbb[19].idCommand = IDM_COMPILE_RUN

   tbb[20].fsStyle = TBSTYLE_SEP
   
   tbb[21].iBitmap = 14
   tbb[21].fsState = TBSTATE_ENABLED
   tbb[21].fsStyle = TBSTYLE_BUTTON
   tbb[21].idCommand = IDM_HELP_ABOUT
      
   SendMessage( hToolBar, TB_ADDBUTTONS, countof(tbb), &tbb )

end sub

sub showToolTips(sys lParam)
   ' Tooltips for Toolbar
   ' lParam holds the notification

   TOOLTIPTEXT *lpttt
   &lpttt = lParam

   string TTText
            
   if (int) lpttt.hdr.code = TTN_NEEDTEXT then
     select lpttt.hdr.idFrom   
     case IDM_FILE_NEW
        TTText="New File"
     case IDM_FILE_OPEN
        TTText="Open File"
     case IDM_FILE_SAVE
        TTText="Save File"
     case IDM_EDIT_CUT
        TTText="Cut"
     case IDM_EDIT_COPY
        TTText="Copy"
     case IDM_EDIT_PASTE
        TTText="Paste"
     case IDM_EDIT_UNDO
        TTText="Undo"
     case IDM_EDIT_REDO
        TTText="Redo"
     case IDM_FILE_CLOSE
        TTText="Close File"        
     case IDM_SEARCH_FIND
        TTText="Find ..."
     case IDM_SEARCH_REPLACE
        TTText="Replace ..."
     case IDM_WINDOW_NEW
        TTText="New Instance"
     case IDM_TOOLS_DOS
        TTText="Command prompt"
     case IDM_COMPILE_RUN
        TTText="Run .o2bas File"
     case IDM_HELP_ABOUT
        TTText="About"
     end select

     lpttt.szText = TTText

   end if
end sub

'% SCLEX_NULL = 1    'Scintilla.h
 
sub setHighlight(int flag) 
   static sys *Foreground
   static sys *Background
   static sys *Boldfont
   static sys *Italicfont

   select case scheme  
   case 1
     @Foreground = @Foreground1 : @Background=@Background1 : @Boldfont=@Boldfont1 : @Italicfont=@Italicfont1
   case 2
     @Foreground = @Foreground2 : @Background=@Background2 : @Boldfont=@Boldfont2 : @Italicfont=@Italicfont2
   case 3
     @Foreground = @Foreground3 : @Background=@Background3 : @Boldfont=@Boldfont3 : @Italicfont=@Italicfont3
   end select
%  SCI_GETLEXER 4002
   if flag=true then
      '
     'http://search.cpan.org/dist/Wx-Scintilla/lib/Wx/Scintilla/Constant.pm#Lexical_states_for_SCLEX_CPP
     'http://www.garybeene.com/code/gbsnippets_gbs_00663.htm
     '8  vb ***
     '40 lout
     '51 powerbasic
     '75 freebasic

      hSciMsg SCI_SETLEXER, SCLEX_OXYGENBASIC, 0

      hSciMsg SCI_SETKEYWORDS, 0, strptr OxyKeywords
      hSciMsg SCI_SETKEYWORDS, 1, strptr ApiKeywords
      hSciMsg SCI_SETKEYWORDS, 2, strptr AsmKeywords

     'setting RGB colors
      for i=0 to 38
        hSciMsg SCI_STYLESETFONT, i, fnt 'Font
        hSciMsg SCI_STYLESETSIZE, i, fnz 'Font size range
        if i =33 then 'Margin Line Number
          hSciMsg SCI_STYLESETFORE,  i, color[Foreground[i+1]]  'Margin Fore Color          
          hSciMsg SCI_STYLESETBOLD,  i, LN_style_bold           'if Bold
          hSciMsg SCI_STYLESETITALIC,i, LN_style_italic         'if Italic
          hSciMsg SCI_STYLESETBACK,  i, color[Background[i+1]]  'Margin Back Color
        else
          hSciMsg SCI_STYLESETFORE,  i, color[Foreground[i+1]]
          hSciMsg SCI_STYLESETBACK,  i, color[Background[i+1]]
          hSciMsg SCI_STYLESETBOLD,  i, Boldfont[i+1]           'if Bold
          hSciMsg SCI_STYLESETITALIC,i, Italicfont[i+1]         'if italic          
        end if
      next
     '
      hSciMsg SCI_SETMARGINTYPEN,   0, SC_MARGIN_NUMBER
      hSciMsg SCI_SETMARGINWIDTHN,  0, 50
      hSciMsg SCI_SETCARETWIDTH,    3,0
      hSciMsg SCI_SETCARETLINEBACK, color[Foreground[40]]
      hSciMsg SCI_SETCARETFORE,     color[Background[40]]
      hSciMsg SCI_SETCARETLINEVISIBLE, 1, 0
     '
     '               
      hSciMsg SCI_STYLESETFORE, STYLE_BRACELIGHT, color[Foreground[35]]  'set brace highlighting color
      if Boldfont[35]=1 then isBold=true else isBold=false
      hSciMsg SCI_STYLESETBOLD, STYLE_BRACELIGHT, isBold
      hSciMsg SCI_STYLESETBACK, STYLE_BRACELIGHT, color[Background[35]]  'set brace highlighting color
      hSciMsg SCI_STYLESETFORE, STYLE_BRACEBAD,   color[Foreground[36]]  'set brace bad color
      if Boldfont[36]=1 then isBold=true else isBold=false
      hSciMsg SCI_STYLESETBOLD, STYLE_BRACEBAD,   isBold
      hSciMsg SCI_STYLESETBACK, STYLE_BRACEBAD,   color[Background[36]]  'set brace bad color
      
   else
      hSciMsg SCI_SETLEXER, SCLEX_Null, 0          'no lexer
      hSciMsg SCI_StartStyling, 0, 38              'set start of styling to pos 0
      iLen = hSciMsg SCI_GetTextLength, 0, 0       'get len of document
      hSciMsg SCI_SetStyling, iLen, Style_Default  'set style of entire document   
   end if

end sub

sub setIndentGuides()
   hSciMsg SCI_SETTABWIDTH, tabspaces, 0
   hSciMsg SCI_SETUSETABS, false, 0
end sub


sub initScintillaControl(hDlg)

    'USE SCINTILLA

      hSci = gdItem(IDC_UDC_SCINTILLA)

      setHighlight(true)
      setIndentGuides()
      
      SetWindowText hDlg, winCaption 
end sub

sub checkBrace(int pos, bool h_check)
   c=hSciMsg SCI_GETCHARAT, pos, 0
   select case c   
   case 40,41,91,93,123,125       '(),[],{}
      if h_check then
        pos2=hSciMsg SCI_BRACEMATCH, pos, 0
        if pos2 != -1 then
          hSciMsg SCI_BRACEHIGHLIGHT, pos, pos2
        else
          hSciMsg SCI_BRACEBADLIGHT, pos, 0
        end if
      else
        hSciMsg SCI_BRACEBADLIGHT, -1, 0
      end if
   case else
      hSciMsg SCI_BRACEBADLIGHT, -1, 0
   end select
end sub

sub createListing(string fname, listname, options, typ)
   'fname = name.o2bas,name.inc, listname = _assembly.txt, _script.txt, _intermediate.txt
   if not exist compiler then mbox compiler " does not exist" : exit sub
   if changed=true then mbox "Please save and run the file first" : exit sub
   if not exist fname then mbox "no source file loaded": exit sub
   listing=appdir & "\" & listname
   if exist listing then
     check = DeleteFile(listing)
     if check=0 then mbox "Cannot delete existing _" typ ".txt  -- Stop" : exit sub
   end if
   string dos_cmd = "/C " & compiler & options & fname " > " & listing
   ShellExecute(null, null, "cmd.exe", dos_cmd, null, SW_HIDE)
   Sleep(1000)
   if exist listing then ShellExecute (null,"open", extEditor, listing, null, SW_SHOW)
end sub

sub HelpAbout(sys hDlg)
   ' using Msgbox indirect to display About
    MSGBOXPARAMS MsgP

    string msgTitle = "About O2HEdit"
    string MsgSt = "
    OxygenBasic Editor
    using Scintilla Control

    Author: Arnold (2017)

    Based on OxIde for OxyenBasic 29 Apr 2016
    http://www.oxygenbasic.org
    Charles E V Pegge

    Compiled with OxygenBasic
    Version: 
    " & version
 
    
    MsgP.cbSize = sizeof(MSGBOXPARAMS)
    MsgP.hwndOwner = hDlg
    MsgP.hInstance = hResources
    MsgP.lpszCaption = msgTitle
    MsgP.lpszText = MsgSt
    MsgP.dwStyle = MB_OK OR MB_USERICON OR MB_TASKMODAL
    MsgP.lpszIcon = IDI_APPICON
    MessageBoxIndirect MsgP

end sub

sub Credits()
   mbox msgCredits
end sub

sub gotoLine(sys hDlg)
   DialogBox(hResources, IDD_DLG_GOTO, hDlg, @GotoDlg)
end sub

function GotoDlg(sys hDlg, uint Msg, sys wParam, lParam) as bool callback
   select case Msg

   case WM_INITDIALOG
     return true      

   case WM_COMMAND
     select loword(wParam)
     case IDOK
       char buffer[10]
       GetDlgItemText(hDlg, IDC_LINENO, buffer, 10)
       int number=val(buffer)-1
       hSciMsg SCI_GOTOLINE, number,0
       EndDialog(hDlg, IDOK)
     case IDCANCEL
       EndDialog(hDlg, IDCANCEL)
     end select
     
   case else
     return false
   end select

   return true
end function

'globals
bool ShortcutsActive=false

sub HelpShortcuts()
  static sys hsWin
  if not ShortcutsActive then
    hsWin=CreateDialog(hResources, IDD_DLG_HELP_SHORTCUTS, Null, @ShortcutsDlg)
    ShortcutsActive=true
  end if
  if ShortcutsActive then
    SetWindowPos(hsWin, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE )    'HWND_TOPMOST?
  end if
end sub

function ShortcutsDlg(sys hDlg, uint Msg, sys wParam, lParam) as bool callback   
   sys hEdit = gdItem(IDC_DLG_HELP_SHORTCUTS_EDIT)
   select case Msg

   case WM_INITDIALOG
      
   case WM_ACTIVATE
      SetWindowText(hEdit, O2HEditShortcutsText)
      SendMessage(hEdit, EM_SETREADONLY, true, 0)

   case WM_COMMAND
      select loword(wParam)
        case IDOK  
           PostMessage(hDlg, WM_CLOSE, 0, 0)
      end select

   case WM_SETFOCUS
      SendMessage(hEdit, EM_SETSEL, 0,0)
        
   case WM_SIZE  
      RECT rcClient

      GetClientRect(hDlg, &rcClient)

      hEdit = gdItem(IDC_DLG_HELP_SHORTCUTS_EDIT)
      SetWindowPos(hEdit, NULL, 0, 0, rcClient.right, rcClient.bottom, SWP_NOZORDER)

    case WM_CLOSE
      ShortcutsActive=false
      DestroyWindow(hDlg)

    case else
      return false

    end select

    return true
end function

=======================================

'globals
sys hFindDialog, hFindReplaceDialog

string LastSearched="", LastReplaced=""
string LastSearched="", LastReplaced=""


function FindDialog(sys hDlg)
    hFindDialog = CreateDialog(hResources, IDD_FIND, hDlg, @FindDlg)
    return hFindDialog
end function

function FindDlg(sys hDlg, uint Msg, sys wParam, lParam) as bool callback
   indexbase 0

   sys hFindNextBtn    = gdItem IDC_FINDNEXT
   sys hRegExpCheck    = gdItem IDC_FINDREGEX
   sys hFindEdit       = gdItem IDC_FINDEDIT
   sys hDownRadio      = gdItem IDC_FINDDOWN

   Sci_TextToFind FindTxt
   string szBuffer=nuls*256
   string szBuffer2= nuls*256
   dword dwBuffer
   dword dwCurLine


   select case Msg

   case WM_INITDIALOG
      szBuffer=LastSearched
      SendMessage hFindEdit, WM_SETTEXT,0, szBuffer        'Restore the last used Search keyword
      SendMessage hFindEdit, EM_LIMITTEXT,255,0            'Max 255 characters
      SendMessage(hFindEdit, EM_SETSEL, 0,0)

      if SendMessage(hFindEdit, WM_GETTEXTLENGTH,0,0)=0 then  'If no "Search" keyword given
        EnableWindow hFindNextBtn, false
      end if

      SendMessage(hDownRadio, BM_SETCHECK, true,0)

      return true
           
   case WM_COMMAND
      if hiword(wParam) = BN_CLICKED then 'event
        if GetAsyncKeyState(27) 'Escape
          SendMessage(hDlg, WM_CLOSE,0,0)
        end if
      end if 

      select loword(wParam)
      
        case IDC_FINDNEXT    'Find next Button
           SendMessage hFindEdit, WM_GETTEXT,len(szBuffer), szBuffer

           if IsDlgButtonChecked(hDlg, IDC_FINDDOWN) then 
             down=true
             FindTxt.Chrg.cpMin = hSciMsg SCI_GetCurrentPos, 0,0      'if up-curpos, if down-anchor
           else
             if IsDlgButtonChecked(hDlg, IDC_FINDREGEX) then mbox "Regular Expression only downwards possible" : exit function  
             down=false
             FindTxt.Chrg.cpMin = hSciMsg SCI_GetAnchor, 0,0          'if up-curpos, if down-anchor
           end if

           FindTxt.Chrg.cpMax=down * hSciMsg SCI_GetLength, 0,0       'if up-length   if down-0
           FindTxt.lpstrText=szBuffer                                 'The search pattern (NULL terminated)

           dwSearchOptions=0
           if IsDlgButtonChecked(hDlg, IDC_FINDMATCHWORD) then dwSearchOptions=SCFIND_WHOLEWORD
           if IsDlgButtonChecked(hDlg, IDC_FINDMATCHCASE) then dwSearchOptions=dwSearchOptions OR SCFIND_MATCHCASE
           if IsDlgButtonChecked(hDlg, IDC_FINDREGEX) then dwSearchOptions=dwSearchOptions OR SCFIND_REGEXP or SCFIND_POSIX
           if (hSciMsg SCI_FINDTEXT, dwSearchOptions, FindTxt)=-1 then
             mbox "No (more) matches found"
           else
             dwCurLine=hSciMsg SCI_LINEFROMPOSITION,FindTxt.chrgText.cpMin,0
             hSciMsg SCI_ENSUREVISIBLE,dwCurLine,0                    'Open the sub containing this line if necessary
             hSciMsg SCI_SETCURRENTPOS,FindTxt.chrgText.cpMax,0       'Set end of selection
             hSciMsg SCI_SETANCHOR,FindTxt.chrgText.cpMin,0           'Set begin of selection
             hSciMsg SCI_SCROLLCARET,0,0                              'Scroll to the current caret position
           end if

        case IDC_FindEDIT                                             'Edit control with the search keyword
           if hiword(wParam)=EN_CHANGE then
             if SendMessage(hFindEdit, WM_GETTEXTLENGTH,0,0)=0 then   'If no "Search" keyword
               EnableWindow hFindNextBtn, false
             else
               EnableWindow hFindNextBtn, true
             end if
           end if
        
        case IDC_FINDCANCEL   'Cancel        
           PostMessage(hDlg, WM_CLOSE, 0, 0)
      end select

   case WM_CLOSE
      SendMessage hFindEdit, WM_GETTEXT,len(szBuffer),szBuffer
      LastSearched=szBuffer                  'Store the last used Search keyword in global variable
      hFindDialog=INVALID_HANDLE_VALUE       'Invalidate dialog handle (for IsDialogMessage call)
      SetFocus hSci

      DestroyWindow(hDlg)

   case else
      return false

   end select

   return true
end function

function FindReplaceDialog(sys hDlg)
    hFindReplaceDialog = CreateDialog(hResources, IDD_REP, hDlg, @FindReplaceDlg)
    return hFindReplaceDialog
end function

function FindReplaceDlg(sys hDlg, uint Msg, sys wParam, lParam) as bool callback   
   indexbase 0
   
   sys hFindNxtBtn     = gdItem IDC_REPFINDNEXT
   sys hReplaceBtn     = gdItem IDC_REPREPLACE
   sys ReplaceAllBtn   = gdItem IDC_REPREPLACEALL
   sys hEditFind       = gdItem IDC_REPEDITF
   sys hEditReplace    = gdItem IDC_REPEDITR
   sys hRegExpCheck    = gdItem IDC_REPREGEX
   sys hDownRadio      = gdItem IDC_REPDOWN

   Sci_TextToFind FindTxt
   string szBuffer=nuls*256
   string szBuffer2=nuls*256
   
   string BufferReFind
   string BufferReReplace
   dword dwLenBufferReFind
   
   dword dwBuffer, dwCurLine, dwLenszBuffer,dwLenszBuffer2, dwEndOfText
   int lCurPos

   select case Msg

   case WM_INITDIALOG
      szBuffer=LastSearched
      SendMessage hEditFind, WM_SETTEXT,0, szBuffer            'Restore the last used Search keyword
      SendMessage hEditFind, EM_LIMITTEXT,255,0                'Max 255 characters

      szBuffer=LastReplaced
      SendMessage hEditReplace, WM_SETTEXT,0, szBuffer         'Restore the last used Replace keyword
      SendMessage hEditReplace, EM_LIMITTEXT,255,0             'Max 255 characters

      EnableWindow hReplaceBtn, false                          'User must first do successfull search
      if SendMessage(hEditFind, WM_GETTEXTLENGTH,0,0)=0 then   'If no "Search" keyword given
        EnableWindow hFindNxtBtn, false
        EnableWindow ReplaceAllBtn, false
      end if

      SendMessage(hDownRadio, BM_SETCHECK, true,0)

      return true

   case WM_COMMAND
      if hiword(wParam) = BN_CLICKED then 'event
        if GetAsyncKeyState(27) 'Escape
          SendMessage(hDlg, WM_CLOSE,0,0)
        end if
      end if 

      select loword(wParam)

        case IDC_REPFINDNEXT
           SendMessage hEditFind, WM_GETTEXT,len(szBuffer), szBuffer

           if IsDlgButtonChecked(hDlg, IDC_REPDOWN) then 
             down=true
             FindTxt.Chrg.cpMin = hSciMsg SCI_GetCurrentPos, 0,0      'if up-curpos, if down-anchor
           else  
             if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then mbox "Regular Expression only downwards possible" : exit function
             down=false
             FindTxt.Chrg.cpMin = hSciMsg SCI_GetAnchor, 0,0          'if up-curpos, if down-anchor
           end if

           FindTxt.Chrg.cpMax=down * hSciMsg SCI_GetLength, 0,0       'if up-length   if down-0
           FindTxt.lpstrText=szBuffer                                 'The search pattern (NULL terminated)

           if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then 
             BufferReFind=szBuffer
           end if

           dwSearchOptions=0
           if IsDlgButtonChecked(hDlg, IDC_REPMATCHWORD) then dwSearchOptions= SCFIND_WHOLEWORD
           if IsDlgButtonChecked(hDlg, IDC_REPMATCHCASE) then dwSearchOptions=dwSearchOptions OR SCFIND_MATCHCASE
           if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then dwSearchOptions=dwSearchOptions OR SCFIND_REGEXP or SCFIND_POSIX
           if (hSciMsg SCI_FINDTEXT, dwSearchOptions, FindTxt)=-1 then
             mbox "No (more) matches found"
           else
             dwCurLine=hSciMsg SCI_LINEFROMPOSITION,FindTxt.chrgText.cpMin,0
             hSciMsg SCI_ENSUREVISIBLE,dwCurLine,0                    'Open the sub containing this line if necessary
             hSciMsg SCI_SETCURRENTPOS,FindTxt.chrgText.cpMax,0       'Set end of selection
             hSciMsg SCI_SETANCHOR,FindTxt.chrgText.cpMin,0           'Set begin of selection
             hSciMsg SCI_SCROLLCARET,0,0                              'Scroll to the current caret position
             EnableWindow hReplaceBtn, true
           end if

        case IDC_REPREPLACE
           FindTxt.chrgText.cpMax=hSciMsg SCI_GETCURRENTPOS, 0,0      'Get end of selection
           FindTxt.chrgText.cpMin=hSciMsg SCI_GETANCHOR, 0,0          'Get begin of selection
           if FindTxt.chrgText.cpMax=FindTxt.chrgText.cpMin then
             mbox"There is no selected text to replace."+crlf +
                        "Use Find next first."
             EnableWindow hReplaceBtn, false
           else
             if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then 
               SendMessage hEditReplace, WM_GETTEXT, len(szBuffer), szBuffer           
               BufferReReplace=szBuffer
               hSciMsg SCI_TARGETFROMSELECTION, 0,0
               hSciMsg SCI_REPLACETARGETRE, -1, BufferReReplace
               newpos= (hSciMsg SCI_GETANCHOR,0,0)+len(ltrim(rtrim(szBuffer)))              
               hSciMsg SCI_GOTOPOS , newpos, 0
               PostMessage hDlg, WM_COMMAND, IDC_REPFINDNEXT,0                  'Search next
             else          
               SendMessage hEditReplace, WM_GETTEXT, len(szBuffer), szBuffer   
               hSciMsg SCI_REPLACESEL,0, szBuffer
               PostMessage hDlg, WM_COMMAND, IDC_REPFINDNEXT,0                  'Search next
             end if
           end if

        case IDC_REPREPLACEALL                                                  'Button "Replace all"
           SendMessage hEditFind, WM_GETTEXT, len(szBuffer), szBuffer
           SendMessage hEditReplace, WM_GETTEXT, len(szBuffer2), szBuffer2
           szBuffer=ltrim rtrim(szBuffer) : szBuffer2=ltrim rtrim(szBuffer2)
           dwLenszBuffer=len(szBuffer) : dwLenszBuffer2=len(szBuffer2)       
          '
           if IsDlgButtonChecked(hDlg, IDC_REPUP) then
             mbox "Replace all will only work downwards from the current position"
             exit function
           end if          

           dwSearchOptions=0
           if IsDlgButtonChecked(hDlg, IDC_REPMATCHWORD) then dwSearchOptions= SCFIND_WHOLEWORD
           if IsDlgButtonChecked(hDlg, IDC_REPMATCHCASE) then dwSearchOptions=dwSearchOptions Or SCFIND_MATCHCASE
           if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then dwSearchOptions=dwSearchOptions OR SCFIND_REGEXP or SCFIND_POSIX
           hSciMsg SCI_SETSEARCHFLAGS,dwSearchOptions,0
           anchor=hSciMsg SCI_GETANCHOR, 0,0
           hSciMsg SCI_SETTARGETSTART, anchor,0      'Start is begin of current selection
           dwEndOfText=hSciMsg SCI_GETLENGTH, 0,0    'End of document position
           hSciMsg SCI_SETTARGETEND,dwEndOfText,0    'End is end of document
           dwBuffer=0 'Counter
           lCurPos=0

           do
             if (dwBuffer and &B00000001) then        'Show we are still working (replacing needs some time!)
               SetCursor LoadCursor(null, IDC_APPSTARTING)
             else
               SetCursor LoadCursor(null, IDC_WAIT)
             end if
             lCurPos=hSciMsg SCI_SEARCHINTARGET,dwLenszBuffer, szBuffer  'Search and set new target
             if lCurPos=-1 then exit do
             if IsDlgButtonChecked(hDlg, IDC_REPREGEX) then
               hSciMsg SCI_REPLACETARGETRE, dwLenszBuffer2, szBuffer2
             else
               hSciMsg SCI_REPLACETARGET,dwLenszBuffer2, szBuffer2       'Replace text in target
             end if
             hSciMsg SCI_SETTARGETSTART,(lCurPos+dwLenszBuffer2),0       'New target start
             hSciMsg SCI_SETTARGETEND,dwEndOfText,0                      'Target end is end of document
             dwBuffer += 1  'Counter
             if dwBuffer=5000 then exit do
           end do

           SetCursor LoadCursor(null, IDC_ARROW)
           lCurPos=hSciMsg SCI_GETTARGETSTART,0,0
           hSciMsg SCI_SETCURRENTPOS, lCurPos,0                          'Select last replaced word (end of selection)
           hSciMsg SCI_SETANCHOR,(lCurPos-dwLenszBuffer2),0              'Set begin of selection
           dwCurLine=hSciMsg SCI_LINEFROMPOSITION,lCurPos,0

           hSciMsg SCI_ENSUREVISIBLE, dwCurLine ,0                       'Open the sub containing this line if necessary
           hSciMsg SCI_SCROLLCARET,0,0                                   'Scroll to the current caret position

           stoptxt="" : if dwBuffer=5000 then stoptxt="Break - "
           mbox stoptxt & dwBuffer +" item(s) replaced."
                
        case IDC_REPEDITF                                                'Edit control with the search keyword
           if hiword(wParam)= EN_CHANGE then
             EnableWindow hReplaceBtn, false                             'When the user changes the search keyword he must first do a successfull Search before Replace
             if SendMessage(hEditFind, WM_GETTEXTLENGTH,0,0)=0 then      'If no "Search" keyword
               EnableWindow hFindNxtBtn, false
               EnableWindow ReplaceAllBtn, false
             else
               EnableWindow hFindNxtBtn, true
               EnableWindow ReplaceAllBtn, true
             end if
           end if


        case IDC_REPCANCEL
           PostMessage(hDlg, WM_CLOSE, 0, 0)
      end select
        
   case WM_CLOSE
      SendMessage hEditFind, WM_GETTEXT,len(szBuffer),szBuffer
      LastSearched=szBuffer                      'Store the last used Search keyword in global variable
      SendMessage hEditReplace, WM_GETTEXT,len(szBuffer), szBuffer
      LastReplaced=szBuffer                      'Store the last used Replace keyword in global variable
      hFindReplaceDialog=INVALID_HANDLE_VALUE    'Invalidate dialog handle (for IsDialogMessage call)
      SetFocus hSci

      DestroyWindow(hDlg)

   case else
      return false

   end select

    return true
end function

function GetCurrentLine() as int
   'Line number of caret
   curpos = hSciMsg SCI_GETCURRENTPOS,0,0
   linenum = hSciMsg SCI_LINEFROMPOSITION, curpos, 0
   return linenum
end function

sub AutoIndent()
   zstring szLineBuffer[1024]
   sys lLenLineBuffer,lCurLine,lLineLength,lPrevLineLength
   int iCurChar
   lLenLineBuffer=len(szLineBuffer)
   lCurLine=GetCurrentLine()   
   lLineLength=hSciMsg SCI_LINELENGTH,lCurLine,0
   'New empty line and not the very first line
   if lCurLine>0 and lLineLength<=2 then
     lPrevLineLength=hSciMsg SCI_LINELENGTH,(lCurLine-1),0     
     if lPrevLineLength<countof(szLineBuffer) then
       hSciMsg SCI_GETLINE,(lCurLine-1), szLineBuffer
       for i=0 to lPrevLineLength-1
         iCurChar = asc(szLineBuffer,i)         
         'no space and no tab
         if iCurChar != 32 and iCurChar != 9 then        
           szLineBuffer[i]=chr(0)
           exit for
         end if
       next i
       hSciMsg SCI_REPLACESEL,0, szLineBuffer
     end if
   end if
end sub

sub environment(sys hDlg)
   DialogBox(hResources, IDD_ENVIRON, hDlg, @environDlg)
end sub

function environDlg(sys hDlg, uint Msg, sys wParam, lParam) as bool callback

   static sys hEdit_compiler, hEdit_scilex, hEdit_rccomp, hEdit_reslnk, hEdit_resed   
   static sys hEdit_exted, hEdit_oxyhlp, hEdit_winhlp  

   select case Msg

   case WM_INITDIALOG
     'fill edit fields
     hEdit_compiler=gdItem(IDC_ENV_OXYCOMP)   : SetText(hEdit_compiler, compiler)
     hEdit_scilex  =gdItem(IDC_ENV_SCILEX)    : SetText(hEdit_scilex, Scilib)
     hEdit_rccomp  =gdItem(IDC_ENV_RCCOMP)    : SetText(hEdit_rccomp, RcCompiler)
     hEdit_reslnk  =gdItem(IDC_ENV_RESLNK)    : SetText(hEdit_reslnk, ResLinker) 
     hEdit_resed   =gdItem(IDC_ENV_RESEDITOR) : SetText(hEdit_resed, ResEditor)
     hEdit_exted   =gdItem(IDC_ENV_EXTEDITOR) : SetText(hEdit_exted, ExtEditor)
     hEdit_oxyhlp  =gdItem(IDC_ENV_OXYHELP)   : SetText(hEdit_oxyhlp, OxyHelp)
     hEdit_winhlp  =gdItem(IDC_ENV_WINHELP)   : SetText(hEdit_winhlp, WinApiHelp)
     
     return true      

   case WM_COMMAND
     select loword(wParam)
     
     case IDC_ENV_OXYCOMPBTN        
        fn=GetTheFileName(compiler, 0, "*.exe", "Please select OxygenBasic Compiler")
        if len(fn) then SetText hEdit_compiler,fn 
     case IDC_ENV_SCILEXBTN
        fn=GetTheFileName(Scilib, 0, "*.dll", "Please select Scintilla Scilexer.dll")
        if len(fn) then SetText hEdit_scilex,fn   
     case IDC_ENV_RCCOMPBTN
        fn=GetTheFileName(RcCompiler, 0, "*.exe", "Please select Resource Compiler")
        if len(fn) then SetText hEdit_rccomp,fn   
     case IDC_ENV_RESLNKBTN
        fn=GetTheFileName(ResLinker, 0, "*.exe", "Please select Resource Linker")
        if len(fn) then SetText hEdit_reslnk,fn   
     case IDC_ENV_RESEDITORBTN
        fn=GetTheFileName(ResEditor, 0, "*.exe", "Please select Resource Editor")
        if len(fn) then SetText hEdit_resed,fn    
     case IDC_ENV_EXTEDITORBTN
        fn=GetTheFileName(ExtEditor, 0, "*.exe", "Please select External Text Editor")
        if len(fn) then SetText hEdit_exted,fn    
     case IDC_ENV_OXYHELPBTN
        fn=GetTheFileName(OxyHelp, 0, "*.chm", "Please select OxygenBasic Help File")
        if len(fn) then SetText hEdit_oxyhlp,fn   
     case IDC_ENV_WINHELPBTN
        fn=GetTheFileName(WinApiHelp, 0, "*.chm", "Please select Win32Api Help File")
        if len(fn) then SetText hEdit_winhlp,fn   
         
     case IDOK
        compiler=GetText(hEdit_compiler)        
        if instr(compiler,"co2.exe") then 
          compilername="co2.exe"
        elseif instr(compiler,"gxo2.exe") then   
          compilername="gxo2.exe" 
        else
          mbox "Wrong compiler"
        end if
        Scilib    =GetText(hEdit_scilex)
        RcCompiler=GetText(hEdit_rccomp)
        ResLinker =GetText(hEdit_reslnk)
        ResEditor =GetText(hEdit_resed)
        ExtEditor =GetText(hEdit_exted) 
        OxyHelp   =GetText(hEdit_oxyhlp)
        WinApiHelp=GetText(hEdit_winhlp)

        saveConfig()
        mbox "O2HEdit.cfg saved." & crlf &      
             "If a different Scilexer.dll is used then" & crlf &
             "O2HEdit must be restarted."
        
        EndDialog(hDlg, IDOK)

     case IDCANCEL
        EndDialog(hDlg, IDCANCEL)
     end select
     
   case else
      return false
   end select

   return true
end function

=============================
type FONT_TYPE
   LOGFONT lf
   int  SIZE
   int  Bold
   int  Italic
   zstring Name[LF_FACESIZE]  
end type

===============================

function GetFontDlg(sys hdlg) as int
   FONT_TYPE ED_FONT

   ED_FONT.lf.lfFaceName=fnt
   ED_FONT.SIZE=fnz

   CHOOSEFONT_ cf
   sys hdc = GetDC(hdlg)
   ED_FONT.lf.lfHeight = -MulDiv(ED_FONT.SIZE, GetDeviceCaps(hdc, LOGPIXELSY), 72)
   ReleaseDC(0,hdc)
 
   cf.lStructSize=sizeof(CHOOSEFONT_)
   cf.hwndOwner=hdlg
   cf.lpLogFont = &ED_FONT.lf
   cf.Flags=CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS | CF_FIXEDPITCHONLY

   int result=ChooseFont(cf)  
   if result then
     ED_FONT.SIZE=cf.iPointSize\10
     ED_FONT.Name=ED_FONT.lf.lfFaceName
     ED_FONT.Bold=ED_FONT.lf.lfWeight
     ED_FONT.Italic=ED_FONT.lf.lfItalic     
   
     fnz=ED_FONT.SIZE
     fnt=ED_FONT.Name
     if ED_FONT.Bold > 400 then LN_style_bold=true else LN_style_bold=false
     if ED_FONT.Italic>0 then LN_style_italic=true else LN_style_italic=false
   end if
   return result
end function

'print "ok"