include once "$/inc/minwin.inc"

'additional Winapi constants
% SM_CXSCREEN=0
% SM_CYSCREEN=1
% SM_CYCAPTION=4
% IMAGE_BITMAP=0
% LR_LOADTRANSPARENT=32
% LR_LOADMAP3DCOLORS=4096
% SB_SETPARTS=1028
% SB_SETTEXT=1025
% TB_AUTOSIZE=1057 
% TBSTYLE_BUTTON=0
% TBSTYLE_SEP=1
% TBSTATE_ENABLED=4
% TB_BUTTONSTRUCTSIZE=1054
% TB_SETBUTTONSIZE=1055
% TB_ADDBITMAP=1043
% TB_ADDBUTTONS=1044
% TTN_NEEDTEXT=-520
% SWP_NOSIZE=1
% SWP_NOMOVE=2
% SWP_NOZORDER=4
% ICON_BIG=1
% WM_SETICON=128
% HWND_TOP=0
% HWND_TOPMOST=-1
% IDC_APPSTARTING=32650
% IDC_WAIT=32514
% CF_INITTOLOGFONTSTRUCT=64
% CF_SCREENFONTS=1
% CF_FIXEDPITCHONLY=16384
% LOGPIXELSY=90
% DEFAULT_GUI_FONT=17

'htmlhelp.h
% HH_CLOSE_ALL=0x0012  'Close all windows opened directly or indirectly by the caller
% HH_DISPLAY_INDEX=0x0002
% HH_DISPLAY_TOPIC=0x0000
% HH_DISPLAY_TOC=0x0001
% HH_KEYWORD_LOOKUP=0x000D

'shlobj.h
% BIF_RETURNONLYFSDIRS  0x0001

'addional WinApi types
type TOOLTIPTEXT
  NMHDR    hdr
  char*    lpszText
  zstring  szText[80]
  sys      hinst
  uint     uFlags
end type

type TBADDBITMAP
  sys  hInst
  sys  nID
end type

type TBBUTTON
  int       iBitmap
  int       idCommand
  BYTE      fsState
  BYTE      fsStyle
'#ifdef _WIN64
''  BYTE      bReserved[6]
'#else 
'#if defined(_WIN32)  
''  BYTE      bReserved[2]
  dword     dwData
  sys       iString
end type
'print sizeof(TBBUTTON) 'Win32=20

type MSGBOXPARAMS
    uint   cbSize
    sys    hwndOwner
    sys    hInstance
    char*  lpszText
    char*  lpszCaption
    dword  dwStyle
    sys    lpszIcon
    dword  dwContextHelpId
    sys    lpfnMsgBoxCallback
    dword  dwLanguageId
end type

type CHOOSEFONT_
  dword lStructSize
  sys   hwndOwner
  sys   hdc
  sys   lpLogFont
  int   iPointSize 
  dword flags 
  int   rgbColors 
  sys   lCustData 
  sys   lpfnHook
  char* lpTemplateName  '?'
  sys   hInstance
  char* lpszStyle         '?'
  word  nFontType 
  word  MISSING_ALIGNMENT
  int   nSizeMin 
  int   nSizeMax 
end type

'htmlhelp.h
type HH_AKLINK
  int   cbStruct
  bool  fReserved
  char* pszKeywords
  char* pszUrl
  char* pszMsgText
  char* pszMsgTitle
  char* pszWindow
  bool  fIndexOnFail
end type

'shlobj.h
type BrowseInfo
    sys   hWndOwner
    sys   pIDLRoot
    sys   pszDisplayName
    char* lpszTitle
    sys   ulFlags
    sys   lpfnCallback
    sys   lParam
    sys   iImage
end type


'additional Winapi functions
! CreateDialogParam lib "user32.dll" alias "CreateDialogParamA"(sys hInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam) as sys
function CreateDialog(sys hInstance, lpTemplate, hWndParent, lpDlgFunc, optional dwInitParam=0) as sys
   return CreateDialogParam(hInstance, lpTemplate, hWndParent, lpDlgFunc, dwInitParam)
end function

' ! DialogBoxParam lib "user32.dll" alias "DialogBoxParamA"(sys hInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam) as sys
function DialogBox(sys hInstance, lpTemplate, hWndParent, lpDialogFunc, optional dwInitParam=0) as sys
   return DialogBoxParam(hInstance, lpTemplate, hWndParent, lpDialogFunc, dwInitParam)
end function
! LoadMenu lib "user32.dll" alias "LoadMenuA"(sys hInstance, sys lpMenuName) as sys
! MessageBoxIndirect lib "user32.dll" alias "MessageBoxIndirectA" (sys *lpMsgBoxParams) as int
! GetDlgItem lib "user32.dll" (sys hDlg, int nIDDlgItem) as sys
! IsDialogMessage lib "user32.dll" alias"IsDialogMessageA" (sys hDlg, sys lpMsg) as bool
! GetDlgItemText lib "user32.dll" alias"GetDlgItemTextA" (sys hDlg, int nIDDlgItem, char* lpString, int nMaxCount) as uint
! GetFileAttributes lib "kernel32.dll" alias "GetFileAttributesA" (char* lpFileName) as dword
! SetFileAttributes lib "kernel32.dll" alias "SetFileAttributesA" (char* lpFileName, dword dwFileAttributes) as bool
! EnableWindow lib "user32.dll" (sys hWnd, bool bEnable) as bool
! IsDlgButtonChecked lib "user32.dll" (sys hDlg, int nIDButton) as uint
! HtmlHelp lib "hhctrl.ocx" alias "HtmlHelpA" (dword hwndCaller, char* pszFile, dword uCommand, dword dwData) as sys
! SetCaretPos lib "user32.dll" (int X, int Y) as bool
! GetDlgCtrlID lib "user32.dll" (sys hwndCtl) as int
! SetCursor lib "user32.dll" (sys hCursor) as sys
! SHBrowseForFolder lib "shell32.dll" ( BrowseInfo *lpbi) as sys
! SHGetPathFromIDList Lib "shell32.dll" (sys pidList, string lpBuffer) as sys
! MoveFile lib "kernel32.dll" alias "MoveFileA" (char* lpExistingFileName,char* lpNewFileName) as bool
! MulDiv lib "kernel32.dll" (int nNumber,int nNumerator,int nDenominator) as int
! GetDeviceCaps lib "gdi32.dll" (sys hdc, int nIndex) as int
! ChooseFont lib "comdlg32.dll" alias"ChooseFontA" (CHOOSEFONT_ *lpcf) as bool
! GetObject lib "gdi32.dll" alias"GetObjectA" (sys hgdiobj, int cbBuffer, VOID *lpvObject) as int


'Register Common Controls
'==============================================================================
% ICC_LISTVIEW_CLASSES    &h1
% ICC_TREEVIEW_CLASSES    &h2
% ICC_BAR_CLASSES         &h4
% ICC_TAB_CLASSES         &h8
% ICC_UPDOWN_CLASS        &h10
% ICC_PROGRESS_CLASS      &h20
% ICC_HOTKEY_CLASS        &h40
% ICC_ANIMATE_CLASS       &h80
% ICC_WIN95_CLASSES       &hff
% ICC_DATE_CLASSES        &h100
% ICC_USEREX_CLASSES      &h200
% ICC_COOL_CLASSES        &h400
% ICC_INTERNET_CLASSES    &h800
% ICC_PAGESCROLLER_CLASS  &h1000
% ICC_NATIVEFNTCTL_CLASS  &h2000
% ICC_STANDARD_CLASSES    &h4000
% ICC_LINK_CLASS          &h8000
'==============================================================================

' create a structure of INITCOMMONCONTROLSEX
INITCOMMONCONTROLSEXt iccex

iccex.dwSize=sizeof(iccex)
iccex.dwICC=ICC_LISTVIEW_CLASSES | ICC_TREEVIEW_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_UPDOWN_CLASS |
            ICC_PROGRESS_CLASS | ICC_TAB_CLASSES | ICC_UPDOWN_CLASS | ICC_PROGRESS_CLASS | ICC_HOTKEY_CLASS |
            ICC_ANIMATE_CLASS | ICC_WIN95_CLASSES | ICC_DATE_CLASSES | ICC_USEREX_CLASSES | ICC_COOL_CLASSES |
            ICC_INTERNET_CLASSES | ICC_PAGESCROLLER_CLASS | ICC_NATIVEFNTCTL_CLASS | ICC_STANDARD_CLASSES | ICC_LINK_CLASS

InitCommonControlsEx(@iccex)



'extracted from scintilla
#define SCLEX_CONTAINER 0
#define SCLEX_NULL 1
#define SCLEX_VB 8
#define SCLEX_VBSCRIPT 28
#define SCLEX_LOUT 40
#define SCLEX_POWERBASIC 51
#define SCLEX_BLITZBASIC 66
#define SCLEX_PUREBASIC 67
#define SCLEX_FREEBASIC 75
#define SCLEX_OXYGENBASIC 200
#define SCE_B_DEFAULT 0
#define SCE_B_COMMENT 1
#define SCE_B_NUMBER 2
#define SCE_B_KEYWORD 3
#define SCE_B_STRING 4
#define SCE_B_PREPROCESSOR 5
#define SCE_B_OPERATOR 6
#define SCE_B_IDENTIFIER 7
#define SCE_B_DATE 8
#define SCE_B_STRINGEOL 9
#define SCE_B_KEYWORD2 10
#define SCE_B_KEYWORD3 11
#define SCE_B_KEYWORD4 12
#define SCE_B_CONSTANT 13
#define SCE_B_ASM 14
#define SCE_B_LABEL 15
#define SCE_B_ERROR 16
#define SCE_B_HEXNUMBER 17
#define SCE_B_BINNUMBER 18
#define SCE_B_COMMENTBLOCK 19
#define SCE_B_DOCLINE 20
#define SCE_B_DOCBLOCK 21
#define SCE_B_DOCKEYWORD 22
#define SCE_B_COMMENTBLOCK1 23
#define SCE_B_COMMENTLINE 24
#define SCE_B_STRING_GRAVE 25
#define SCE_LOUT_DEFAULT 0
#define SCE_LOUT_COMMENT 1
#define SCE_LOUT_NUMBER 2
#define SCE_LOUT_WORD 3
#define SCE_LOUT_WORD2 4
#define SCE_LOUT_WORD3 5
#define SCE_LOUT_WORD4 6
#define SCE_LOUT_STRING 7
#define SCE_LOUT_OPERATOR 8
#define SCE_LOUT_IDENTIFIER 9
#define SCE_LOUT_STRINGEOL 10

' Scintilla.h

'%  SCINTILLA_H

/* Here should be placed typedefs for uptr_t, an unsigned integer type large enough to
 * hold a pointer and sptr_t, a signed integer large enough to hold a pointer.
 * May need to be changed for 64 bit platforms. */

typedef sys sptr_t,uptr_t

typedef sptr_t (*SciFnDirect)(sptr_t ptr, unsigned int iMessage, uptr_t wParam, sptr_t lParam);


#define SCI_TARGETFROMSELECTION 2287
%  SC_EOL_CR 1
%  SC_EOL_CRLF 0
%  SC_EOL_LF 2
%  SC_MARGIN_BACK 2
%  SC_MARGIN_FORE 3
%  SC_MARGIN_NUMBER 1
%  SC_MARGIN_RTEXT 5
%  SC_MARGIN_SYMBOL 0
%  SC_MARGIN_TEXT 4
%  SCFIND_MATCHCASE 4
%  SCFIND_POSIX 0x00400000
%  SCFIND_REGEXP 0x00200000
%  SCFIND_WHOLEWORD 2
%  SCFIND_WORDSTART 0x00100000
%  SCI_BRACEBADLIGHT 2352
%  SCI_BRACEHIGHLIGHT 2351
%  SCI_BRACEMATCH 2353
%  SCI_CLEAR 2180
%  SCI_CONVERTEOLS 2029
%  SCI_COPY 2178
%  SCI_CUT 2177
%  SCI_EMPTYUNDOBUFFER 2175
%  SCI_ENSUREVISIBLE 2232
%  SCI_FINDTEXT 2150
%  SCI_GETANCHOR 2009
%  SCI_GETCARETLINEBACK 2097
%  SCI_GETCARETLINEBACK 2097
%  SCI_GETCARETLINEVISIBLE 2095
%  SCI_GETCHARAT 2007
%  SCI_GETCOLUMN 2129
%  SCI_GETCURLINE 2027
%  SCI_GETCURRENTPOS 2008
%  SCI_GETENDSTYLED 2028
%  SCI_GETEOLMODE 2030
%  SCI_GETLENGTH 2006
%  SCI_GETLINE 2153
%  SCI_GETLINECOUNT 2154
%  SCI_GETLINESTATE 2093
%  SCI_GETLINEVISIBLE 2228
%  SCI_GETMARGINLEFT 2156
%  SCI_GETMARGINRIGHT 2158
%  SCI_GETMARGINTYPEN 2241
%  SCI_GETMARGINWIDTHN 2243
%  SCI_GETMAXLINESTATE 2094
%  SCI_GETMODIFY 2159
%  SCI_GETOVERTYPE 2187
%  SCI_GETREADONLY 2140
%  SCI_GETSELTEXT 2161
%  SCI_GETSTYLEBITS 2091
%  SCI_GETTARGETEND 2193
%  SCI_GETTARGETEND 2193
%  SCI_GETTARGETSTART 2191
%  SCI_GETTARGETSTART 2191
%  SCI_GETTEXT 2182
%  SCI_GETTEXTLENGTH 2183
%  SCI_GETTEXTRANGE 2162
%  SCI_GETVIEWEOL 2355
%  SCI_GETVIEWWS 2020
%  SCI_GETWHITESPACESIZE 2087
%  SCI_GETZOOM 2374
%  SCI_GOTOLINE 2024
%  SCI_GOTOPOS 2025
%  SCI_LINEFROMPOSITION 2166
%  SCI_LINELENGTH 2350
%  SCI_LINESCROLL 2168
%  SCI_PASTE 2179
%  SCI_REDO 2011
%  SCI_REPLACESEL 2170
%  SCI_REPLACETARGET 2194
%  SCI_REPLACETARGETRE 2195
%  SCI_SCROLLCARET 2169
%  SCI_SEARCHINTARGET 2197
%  SCI_SEARCHINTARGET 2197
%  SCI_SELECTALL 2013
%  SCI_SETANCHOR 2026
%  SCI_SETCARETFORE 2069
%  SCI_SETCARETLINEBACK 2098
%  SCI_SETCARETLINEBACK 2098
%  SCI_SETCARETLINEVISIBLE 2096
%  SCI_SETCARETLINEVISIBLE 2096
%  SCI_SETCARETWIDTH 2188
%  SCI_SETCURRENTPOS 2141
%  SCI_SETEOLMODE 2031
%  SCI_SETKEYWORDS 4005
%  SCI_SETLEXER 4001
%  SCI_SETLINESTATE 2092
%  SCI_SETMARGINLEFT 2155
%  SCI_SETMARGINRIGHT 2157
%  SCI_SETMARGINTYPEN 2240
%  SCI_SETMARGINWIDTHN 2242
%  SCI_SETREADONLY 2171
%  SCI_SETSAVEPOINT 2014
%  SCI_SETSEARCHFLAGS 2198
%  SCI_SETSEL 2160
%  SCI_SETSTYLEBITS 2090
%  SCI_SETSTYLING 2033
%  SCI_SETTABWIDTH 2036
%  SCI_SETTARGETEND 2192
%  SCI_SETTARGETEND 2192
%  SCI_SETTARGETSTART 2190
%  SCI_SETTEXT 2181
%  SCI_SETUSETABS 2124
%  SCI_SETVIEWEOL 2356
%  SCI_SETVIEWWS 2021
%  SCI_SETWHITESPACEBACK 2085
%  SCI_SETWHITESPACEFORE 2084
%  SCI_SETWHITESPACESIZE 2086
%  SCI_SETZOOM 2373
%  SCI_STARTSTYLING 2032
%  SCI_STYLESETBACK 2052
%  SCI_STYLESETBOLD 2053
%  SCI_STYLESETCHANGEABLE 2099
%  SCI_STYLESETFONT 2056
%  SCI_STYLESETFORE 2051
%  SCI_STYLESETITALIC 2054
%  SCI_STYLESETSIZE 2055
%  SCI_UNDO 2176
%  SCI_ZOOMIN 2333
%  SCI_ZOOMOUT 2334
%  SCN_CHARADDED 2001
%  SCN_MODIFIED 2008
%  SCN_SAVEPOINTLEFT 2003
%  SCN_UPDATEUI 2007
%  SCWS_INVISIBLE 0
%  SCWS_VISIBLEAFTERINDENT 2
%  SCWS_VISIBLEALWAYS 1
%  STYLE_BRACEBAD 35
%  STYLE_BRACELIGHT 34
%  STYLE_DEFAULT 32
%  STYLE_LINENUMBER 33


/* These structures are defined to be exactly the same shape as the Win32
 * CHARRANGE, TEXTRANGE, FINDTEXTEX, FORMATRANGE, and NMHDR structs.
 * So older code that treats Scintilla as a RichEdit will work. */

#ifdef SCI_NAMESPACE
namespace Scintilla {
#endif

struct Sci_CharacterRange {
    long cpMin;
    long cpMax;
};

struct Sci_TextRange {
    struct Sci_CharacterRange chrg;
    char *lpstrText;
};

struct Sci_TextToFind {
    struct Sci_CharacterRange chrg;
    char *lpstrText;
    struct Sci_CharacterRange chrgText;
};

%  CharacterRange Sci_CharacterRange
%  TextRange Sci_TextRange
%  TextToFind Sci_TextToFind

typedef void *Sci_SurfaceID;

struct Sci_Rectangle {
    int left;
    int top;
    int right;
    int bottom;
};

/* This structure is used in printing and requires some of the graphics types
 * from Platform.h.  Not needed by most client code. */

struct Sci_RangeToFormat {
    Sci_SurfaceID hdc;
    Sci_SurfaceID hdcTarget;
    struct Sci_Rectangle rc;
    struct Sci_Rectangle rcPage;
    struct Sci_CharacterRange chrg;
};

%  RangeToFormat Sci_RangeToFormat

struct Sci_NotifyHeader {
    /* Compatible with Windows NMHDR.
     * hwndFrom is really an environment specific window handle or pointer
     * but most clients of Scintilla.h do not have this type visible. */
    sys hwndFrom;
    uptr_t idFrom;
    dword code;
};

'SCNotification
%  NotifyHeader Sci_NotifyHeader

type SCNotification
    Sci_NotifyHeader nmhdr
    int position;
    /* SCN_STYLENEEDED, SCN_DOUBLECLICK, SCN_MODIFIED, SCN_MARGINCLICK, */
    /* SCN_NEEDSHOWN, SCN_DWELLSTART, SCN_DWELLEND, SCN_CALLTIPCLICK, */
    /* SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK, SCN_HOTSPOTRELEASECLICK, */
    /* SCN_INDICATORCLICK, SCN_INDICATORRELEASE, */
    /* SCN_USERLISTSELECTION, SCN_AUTOCSELECTION */

    int ch
    /* SCN_CHARADDED, SCN_KEY, SCN_AUTOCCOMPLETED, SCN_AUTOCSELECTION, */
    /* SCN_USERLISTSELECTION */
    int modifiers
    /* SCN_KEY, SCN_DOUBLECLICK, SCN_HOTSPOTCLICK, SCN_HOTSPOTDOUBLECLICK, */
    /* SCN_HOTSPOTRELEASECLICK, SCN_INDICATORCLICK, SCN_INDICATORRELEASE, */

    int modificationType    /* SCN_MODIFIED */
    const char *text
    /* SCN_MODIFIED, SCN_USERLISTSELECTION, SCN_AUTOCSELECTION, SCN_URIDROPPED */

    int length        /* SCN_MODIFIED */
    int linesAdded    /* SCN_MODIFIED */
    int message       /* SCN_MACRORECORD */
    uptr_t wParam     /* SCN_MACRORECORD */
    sptr_t lParam     /* SCN_MACRORECORD */
    int line          /* SCN_MODIFIED */
    int foldLevelNow  /* SCN_MODIFIED */
    int foldLevelPrev /* SCN_MODIFIED */
    int margin        /* SCN_MARGINCLICK */
    int listType      /* SCN_USERLISTSELECTION */
    int x             /* SCN_DWELLSTART, SCN_DWELLEND */
    int y             /* SCN_DWELLSTART, SCN_DWELLEND */
    int token         /* SCN_MODIFIED with SC_MOD_CONTAINER */
    int annotationLinesAdded    /* SCN_MODIFIED with SC_MOD_CHANGEANNOTATION */
    int updated                 /* SCN_UPDATEUI */
    int listCompletionMethod
    /* SCN_AUTOCSELECTION, SCN_AUTOCCOMPLETED, SCN_USERLISTSELECTION, */
end type

' INCLUDE_DEPRECATED_FEATURES
#define SCI_SETKEYSUNICODE 2521
#define SCI_GETKEYSUNICODE 2522


'print "ok"