#include "O2HEditApi.inc"
includepath "$/inc/"
  include once "FileDialog.inc"
  include once "SysUtil.inc"

crlf=chr(13,10)

string o2dir="c:\oxygenbasic"
string argOpenFile
string progname, configdir
string appdir
string dir
string caption = "O2HEdit - OxygenBasic Editor using Scintilla"
string winCaption = caption

'Settings
string compiler=o2dir+"\co2.exe"
string compilername="co2.exe"

string SciLib, ResLinker, RcCompiler, ResEditor, ExtEditor, OxyHelp, WinApiHelp
string fnt
sys fnz
bool LN_style_bold  'Line number: Bold
bool LN_style_italic 'Line number: Italic
int tabspaces
int scheme

sys hsci
string openFile, filt
sys mode '0=No File, 1=New File, 2=File Exists
bool changed


'Helper functions

function RGB(int r, g, b) as int
   return (r + g*256 + b*65536)
end function 

function current_dir() as string
   zstring CurDir[1024]
   GetCurrentDirectory( 1024, CurDir)
   return CurDir
end function

function exe_name() as string
   zstring fname[1024]
   GetModuleFileName(NULL, fname, 1024)
   return fname
end function

function app_path(string name) as string
   zstring path[1024]
   sys fp
   GetFullPathName(name, 1024, path, @fp)
   for x=len(path) to 1 step -1
      if asc(path,x)=47 or asc(path,x)=92 then ' / or \
         path=mid(path,1,x-1)
         exit for
      end if
   next x
   if x=0 then
      path=current_dir()
   end if
   return path
end function

=================================================

function Exist_A (char *szFilePath) as bool
  WIN32_FIND_DATA W32FindData
  sys rc
  rc = FindFirstFile(szFilePath, &W32FindData)
  if (rc == INVALID_HANDLE_VALUE) then return FALSE
  FindClose(rc)
  return TRUE
end function

function Exist_B (string szFilePath) as bool
  DWORD ret
  ret = GetFileAttributes(szFilePath)
  if (ret != 0xffffffff) then return TRUE
  return FALSE
end function

function Exist (string szFilePath) as bool
  if (instr(szFilePath, "*") || instr(szFilePath, "?")) then
     return Exist_A (szFilePath)
  end if
  return Exist_B (szFilePath)
end function

sub center(sys hwnd)
    RECT WndRect
    sys x,y
    GetWindowRect(hwnd,&WndRect)
    x = (GETSYSTEMMETRICS(SM_CXSCREEN) - WndRect.Right-WndRect.Left)/2
    y = (GETSYSTEMMETRICS(SM_CYSCREEN) - (WndRect.Bottom-WndRect.Top+GETSYSTEMMETRICS(SM_CYCAPTION)))/2
    SetWindowPos (hWnd, NULL, x, y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
end sub


  function ExtractData(string s,k) as string
  ==========================================
  'format: $keyword [data]
  sys a=instr(s,k)
  if a=0 then exit function
  a=instr a,s,"["
  b=instr a,s,"]"
  if a then
    a++ : return mid s,a,b-a
  end if
  end function

  function ExtractHelpWord(string s,sys *st,*en,*lw) as string
  ==============================================================
  sys le=len s
  for i=st to 1 step-1
    a=asc(s,i)
'    if a<33 then st=i+1 : exit for
''    if a<48 then st=i+1 : exit for
    if a<48 then 
      if a != 35 then st=i+1 : exit for '#
    end if
    if a<65 and a>57 then st=i+1 : exit for
  next
''  if i=0 then st=1
  for i=st+1 to le
    a=asc(s,i)
'    if a<33 then exit for
    if a<48 then exit for
  next
  en=i
  lw=en-st
  return mid(s,st,en-st)
  end function

  function Clipname(string f) as string
  =====================================
  if len(f)>32
    return "..." mid f,-32
  else
    return f
  end if
  end function

  function replace_all(string *s,f,r)
  ====================================
  sys i=1,lf=len(f),lr=len(r)
  if not len f then return
  do
    i=instr i,s,f
    if i=0 then exit do
    s=left(s,i-1)+r+mid(s,i+lf)
    i+=lr
  end do
  end function

  Function Sendm(sys hwnd,optional sys winMsg,sciMsg,wparam,lparam)
  =================================================================
  sys m
  if hsci=hWnd then m=sciMsg else m=winMsg
  if m then SendMessage hwnd,m,wparam,lparam
  end function


  Function SetText(sys hwnd, string s)
  ====================================
  Sendm hwnd,WM_SETTEXT,SCI_SETTEXT,len(s),strptr(s)
  End Function


  Function GetText(sys hwnd) as string
  ====================================
  sys le
  bstring s
  le=sendm hwnd,WM_GETTEXTLENGTH,SCI_GETTEXTLENGTH
  s=nuls le
  sendm hwnd,WM_GETTEXT,SCI_GETTEXT,le+1,strptr(s)
  return s
  end function

function selectFolder(string title) as string 
   string DisplayName=nuls * 256 

   BROWSEINFO bi
   bi.hwndOwner      = null 
   bi.pidlRoot       = null 
   bi.pszDisplayName = DisplayName; 
   bi.lpszTitle      = title '"Please select directory:" 
   bi.ulFlags        = BIF_RETURNONLYFSDIRS
   bi.lParam         = null 
   bi.iImage         = 0  

   sys pidl = SHBrowseForFolder( bi)

   string szPathName = nuls*256 
   if pidl != 0 then
     bool bRet = SHGetPathFromIDList(pidl, szPathName)
     if bRet != false then
       return szPathName
     end if
   end if
   return null
end function

function GetTheFileName(string name, sys a,
            optional string myfilter="", mytitle="") as string
'==============================================================
   '$/inc/FileDialog.inc

   sys hwnd
   string dir=current_dir()

   string sep=chr(0)
   string filter=
     "basic"+sep+"*.bas;*.o2bas"+sep+
     "text"+sep+"*.txt"+sep+
     "bat"+sep+"*.bat"+sep+     
     "all files"+sep+"*.*"+sep+
     "include"+sep+"*.inc"+sep+
     "header"+sep+"*.h"+sep+sep
   if len(myfilter) then filter=myfilter + sep

   string title
   if a then
     title="Save File as"
   else
     title="Load File"
   end if
   if len mytitle then title=mytitle

   sys flags = OFN_EXPLORER or OFN_OVERWRITEPROMPT or OFN_HIDEREADONLY

   string fname = FileDialog(dir,filter,title,name,hwnd,flags,a)
   return fname
end function

sub loadConfig()
   string  s_cfg

   appdir=current_dir()

   if not exist (configdir+"\O2HEdit.cfg") then
     mbox "O2HEdit.cfg not found" & crlf & "using default values"
     'Check if in OxygenBasic directory
     compiler = o2dir & "\" & compilername     
     if not exist compiler then
       compiler = o2dir & "\" & compilername
       if not exist compiler then
         c=GetTheFileName(compilername,0,"*.exe", "Please select OxygenBasic compiler")
         if c then
           pos=instr(c,lcase("\co2.exe"))
           if pos then 
             o2dir=left(c, pos-1) : compiler=c : compilername="gxo2"
           else
             pos=instr(c,lcase("\gxo2.exe"))
             if pos then 
               o2dir=left(c, pos-1) : compiler=c : compilername="gxo2"
             end if
           end if    
         end if
       end if
     end if

     dir=appdir
     fnt="Lucida Console" ' Courier
     fnz=14
     LN_style_bold=0
     LN_style_italic=0
     scheme=1     

     SciLib=o2dir & "\SciLexer.dll"
     ResLinker=o2dir & "\tools\Linkres2exe.exe"
     RcCompiler=o2dir & "\tools\GoRc.exe"
     ResEditor="Resed.exe"
     ExtEditor="Wordpad"
     OxyHelp=o2dir & "\inf\oxygen_help.chm"
     WinApiHelp=o2dir & "\inf\Win32.chm"
/*
print _
o2dir +cr+
compiler+cr+
Scilib+cr+
Reslinker+cr+
RcCompiler+cr+
ResEditor+cr+
OxyHelp+cr+
WinApiHelp+cr+
dir+cr+
tabspaces+cr+
fnt+cr+
fnz+cr+
LN_style_bold+cr+
LN_style_italic+cr+
scheme
*/
     s_cfg= "$o2dir [" & o2dir & "]" & cr &
        "$compiler [" & compiler & "]" & cr &
        "$scilexer [" & SciLib & "]" & cr &
        "$reslinker [" & ResLinker & "]" & cr &
        "$rccompiler [" & RcCompiler & "]" & cr &
        "$reseditor [" & ResEditor & "]" & cr &
        "$editor [" &  extEditor & "]" & cr &
        "$oxyhlp [" & OxyHelp & "]" & cr &
        "$winapihlp [" & WinapiHelp & "]" & cr &
        "$dir [" & dir & "]" & cr &
        "$tabspaces [" & tabspaces & "]" & cr &
        "$font [" & fnt & "]" & cr &
        "$fontsize [" & fnz & "]" & cr &
        "$ln_style_bold [" & LN_style_bold & "]" & cr &
        "$ln_style_italic [" & LN_style_italic & "]" & cr &
        "$clrscheme [" & scheme & "]" & cr

     putfile configdir  & "\O2HEdit.cfg", s_cfg     
     SetCurrentDirectory appdir
     mbox "O2HEdit.cfg saved" 
   end if

   s_cfg=getfile configdir & "\O2HEdit.cfg"
   if s_cfg then
     o2dir=extractData s_cfg, "$o2dir "
     compiler=extractData s_cfg, "$compiler "
     SciLib=extractData s_cfg, "$scilexer "
     ResLinker=extractData s_cfg, "$reslinker "
     RcCompiler=extractData s_cfg, "$rccompiler "
     ResEditor=extractData s_cfg, "$reseditor "
     extEditor=extractData s_cfg, "$editor "
     OxyHelp=extractData s_cfg, "$oxyhlp "          
     WinapiHelp=extractData s_cfg, "$winapihlp "
     dir=extractData s_cfg, "$dir "     
     tabspaces=extractData s_cfg, "$tabspaces "
     if tabspaces<2 then tabspaces=4
     if tabspaces>8 then tabspaces=8
     fnt=extractData s_cfg,"$font "
     fnz=val extractData s_cfg,"$fontsize "
     LN_style_bold=val extractData s_cfg,"$ln_style_bold "
     LN_style_italic=val extractData s_cfg,"$ln_style_italic "     
     scheme=extractData s_cfg, "$clrscheme "
     if instr(compiler, "co2.exe") then
       compilername="co2.exe"
     elseif instr(compiler, "gxo2.exe") then
       compilername="gxo2.exe"
     else
       mbox "Maybe something wrong with compiler" & crlf & "Check MenuItem Options/Environment Settings"
     end if
     compiler = o2dir & "\" & compilername
   else
     mbox "Error: Something terribly wrong."  &  crlf  & "Program will abort."
     ExitProcess(1)
   end if  
end sub

===========================================


sub saveConfig()
   string s_cfg
   char buf[256]
   GetCurrentDirectory 256, buf
/*
print _
o2dir +cr+
compiler+cr+
Scilib+cr+
Reslinker+cr+
RcCompiler+cr+
ResEditor+cr+
OxyHelp+cr+
WinApiHelp+cr+
buf+cr+
tabspaces+cr+
fnt+cr+
fnz+cr+
LN_style_bold+cr+
LN_style_italic+cr+
scheme
*/
   s_cfg="$o2dir ["+o2dir+"]"+cr+
     "$compiler ["+compiler+"]"+cr+
     "$scilexer ["+SciLib+"]"+cr+
     "$reslinker ["+ResLinker+"]"+cr+
     "$rccompiler ["+RcCompiler+"]"+cr+
     "$reseditor ["+ResEditor+"]"+cr+
     "$editor ["+extEditor+"]"+cr+
     "$oxyhlp ["+OxyHelp+"]"+cr+
     "$winapihlp ["+WinapiHelp+"]"+cr+
     "$dir ["+buf+"]"+cr+
     "$tabspaces ["+tabspaces+"]"+cr+
     "$font ["+fnt+"]"+cr+
     "$fontsize [" +fnz+"]"+cr &
     "$ln_style_bold ["+LN_style_bold+"]"+cr+
     "$ln_style_italic ["+LN_style_italic+"]"+cr
      s_cfg &= "$clrscheme [" & str(scheme) & "]"+cr     

   dest=configdir+"\O2HEdit.cfg"
   putfile dest, s_cfg 

end sub

=============================================

  function MaySaveFile(string fname, optional qbox) as sys
  ==========================================================
  'check if a file must be saved and ask
  sys a=IDNO
  string fn=fname
  if fn ="" or mode=1 then
    fn="<New File>"
  end if
  if changed=true then
    if qbox then
      a=MessageBox(0, "Save " fn, qbox, MB_YESNOCANCEL)
    end if
  end if
  return a   
  end function

=============================================

'print "ok"